class SiteUser
{
    $ResponseObject
    [String]$ResponseJson
    [Int]$ProjectId
    [Int]$Id
    [Int]$SourcePoolId
    [Int]$TargetPoolId
    [Int]$SourceRecipientType
    [Int]$TargetRecipientType
    [String]$SourceName
    [String]$SourceId
    [String]$TargetLibrary
    [String]$TargetFolder
    [String]$TargetChannelName
    [String]$TargetName
    [String]$TargetUrl
    [string]$IncludeMappingTable
    [string]$BulkDeleteList
    [string]$count
    [array]$jobSearch
    [int]$BatchID
    [String]$SourceEmail
    [String]$TargetEmail
   

    

    GetSiteList(){
        $BodyJson = @{
            page = 1
            pageSize = 500
        }

        $Parameters = @{
            Method = "Post"
            Uri = "$global:HOSTURL/ap1/Site/Displayable"
            Headers = GetHeader 
            ContentType = "application/json"
            Body = ($BodyJson | ConvertTo-Json)
        }

        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100 
    }

    CreateNew(){
    
        $BodyJson = @{
            
            sourcePoolId = $this.SourcePoolId
            targetPoolId = $this.TargetPoolId
            sourceName = $this.SourceName
            sourceId = $this.SourceId
            sourceRecipientType = $this.SourceRecipientType
            targetName = $this.TargetName
            targetUrl = $this.TargetUrl
            targetRecipientType = $this.TargetRecipientType
            targetChannelName = $this.TargetChannelName
            targetFolder =$this.TargetFolder
            targetLibrary = $this.TargetLibrary
            timeStamp= [DateTime]::UtcNow.ToString('u')
         
        }
    
        $Parameters = @{
            Method = "Post"
            Uri = "$global:HOSTURL/ap1/Site"
            Headers = GetHeader
            ContentType = "application/json"
            Body = ($BodyJson | ConvertTo-Json)
        }
        
        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100   
    }
    Update(){
        
        $objectId = $this.Id
        $BodyJson = @{
            sourcePoolId = $this.SourcePoolId
            targetPoolId = $this.TargetPoolId
            sourceName = $this.SourceName
            sourceId = $this.SourceId
            sourceRecipientType = $this.SourceRecipientType
            targetName = $this.TargetName
            targetUrl = $this.TargetUrl
            targetRecipientType = $this.TargetRecipientType
            targetChannelName = $this.TargetChannelName
            targetFolder =$this.TargetFolder
            targetLibrary = $this.TargetLibrary
            timeStamp= [DateTime]::UtcNow.ToString('u')
         
        }
    
        $Parameters = @{
            Method = "Put"
            Uri = "$global:HOSTURL/ap1/Site/$objectId"
            Headers = GetHeader
            ContentType = "application/json"
            Body = ($BodyJson | ConvertTo-Json)
        }
        
        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100   
    }

    BulkDelete(){
      
        $Parameters = @{
            Method = "Put"
            Uri = "$global:HOSTURL/ap1/Site/BulkDelete/true"
            Headers = GetHeader
            ContentType = "application/json"
            Body = $this.BulkDeleteList   
        }
        
        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100          
    }

    SearchUser(){
   
        $BodyJson=@{ sourceName=$this.SourceName}

        $Parameters = @{
            Method = "Post"
            Uri = "$global:HOSTURL/ap1/Site/SiteSearch"
            Headers = GetHeader 
            ContentType = "application/json"
            Body = ($BodyJson | ConvertTo-Json)
        }
      
        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100  
    }

    GetUserLogs(){
   
        $objectId = $this.Id
        $Parameters = @{
            Method = "Get"
            Uri = "$global:HOSTURL/ap1/Site/logs/$objectId"
            Headers =GetHeader
            ContentType = "application/json"
        }
        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100           
    }

    GetUserStatistics(){
   
        $objectId = $this.Id
        $Parameters = @{
            Method = "Get"
            Uri = "$global:HOSTURL/ap1/Site/SiteStatistics/$objectId"
            Headers =GetHeader
            ContentType = "application/json"
        }
        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100           
    }

    GetBatchList(){
       
        $Parameters = @{
            Method = "Get"
            Uri = "$global:HOSTURL/ap1/Site/Batch"
            Headers = GetHeader 
            ContentType = "application/json"
        }

        $this.ResponseObject = Invoke-FrontAPI($Parameters) | ConvertFrom-Json
        $this.ResponseJson = $this.ResponseObject | ConvertTo-Json -depth 100   
        
    }


}